diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index f0e75173d..207f7e274 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block.entity;
 
 import java.util.*;
 
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
@@ -19,49 +21,49 @@ import org.jetbrains.annotations.NotNull;
 public class TileEntityBasket extends TileEntity
 {
     private int numUnitsInside = 0;
-    private final Map<BasketEntry, Integer> contents = new HashMap<>();
+    private final Object2IntMap<BasketEntry> contents = new Object2IntArrayMap<>();
 
 
     private void updateNumUnits()
     {
-        int prevNum = numUnitsInside;
-        numUnitsInside = 0;
+        final int prevNum = this.numUnitsInside;
+        this.numUnitsInside = 0;
 
-        for (Map.Entry<BasketEntry, Integer> entry : contents.entrySet())
+        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet())
         {
-            BasketEntry be = entry.getKey();
-            int numItems = entry.getValue();
+            final BasketEntry be = entry.getKey();
+            final int numItems = entry.getIntValue();
 
-            int unitsPerItem = getItemSizeUnits(be.getItem());
-            numUnitsInside += (unitsPerItem * numItems);
+            final int unitsPerItem = getItemSizeUnits(be.getItem());
+            this.numUnitsInside += (unitsPerItem * numItems);
         }
-        if (prevNum != numUnitsInside && worldObj != null){
-            worldObj.notifyBlockChange(x, y, z, worldObj.getBlockId(x, y, z));
+        if (prevNum != this.numUnitsInside && this.worldObj != null){
+            this.worldObj.notifyBlockChange(this.x, this.y, this.z, this.worldObj.getBlockId(this.x, this.y, this.z));
         }
     }
 
-    private int getItemSizeUnits(Item item)
+    private int getItemSizeUnits(final Item item)
     {
         return 64 / item.getItemStackLimit(null);
     }
 
 
-    private void dropItemStack(Random rand, ItemStack itemstack)
+    private void dropItemStack(final Random rand, final ItemStack itemstack)
     {
         final float f = rand.nextFloat() * 0.8F + 0.1F;
         final float f1 = rand.nextFloat() * 0.8F + 0.1F;
         final float f2 = rand.nextFloat() * 0.8F + 0.1F;
 
-        World workingWorld;
-        if (worldObj != null) {
-            workingWorld = worldObj;
-        } else if (carriedBlock != null) {
-            workingWorld = carriedBlock.world;
+        final World workingWorld;
+        if (this.worldObj != null) {
+            workingWorld = this.worldObj;
+        } else if (this.carriedBlock != null) {
+            workingWorld = this.carriedBlock.world;
         } else {
             return;
         }
 
-        final EntityItem item = new EntityItem(workingWorld, x + f, y + f1, z + f2, itemstack);
+        final EntityItem item = new EntityItem(workingWorld, this.x + f, this.y + f1, this.z + f2, itemstack);
         final float f3 = 0.05F;
         item.xd = (float) rand.nextGaussian() * f3;
         item.yd = (float) rand.nextGaussian() * f3 + 0.25F;
@@ -71,7 +73,7 @@ public class TileEntityBasket extends TileEntity
 
     public int getNumUnitsInside()
     {
-        return numUnitsInside;
+        return this.numUnitsInside;
     }
 
     public int getMaxUnits()
@@ -80,39 +82,39 @@ public class TileEntityBasket extends TileEntity
     }
 
 	public void givePlayerAllItems(final World world, final Player player) {
-		List<BasketEntry> toRemove = new ArrayList<>();
+		final List<BasketEntry> toRemove = new ArrayList<>();
 
-		for(Map.Entry<BasketEntry, Integer> entry : contents.entrySet()) {
-			BasketEntry basketEntry = entry.getKey();
-			ItemStack basketEntryStack = new ItemStack(basketEntry.id, entry.getValue(), basketEntry.metadata, basketEntry.tag);
+		for(final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet()) {
+			final BasketEntry basketEntry = entry.getKey();
+			final ItemStack basketEntryStack = new ItemStack(basketEntry.id, entry.getIntValue(), basketEntry.metadata, basketEntry.tag);
 			// Beware! basketEntryStack may have a stack size higher than its limit!
 			
 			player.inventory.insertItem(basketEntryStack, true);
-			contents.put(basketEntry, basketEntryStack.stackSize);
+            this.contents.put(basketEntry, basketEntryStack.stackSize);
 			
 			if(basketEntryStack.stackSize <= 0) {
 				toRemove.add(basketEntry);
 			}
 		}
-		
-		for(BasketEntry entry : toRemove) {
-			contents.remove(entry);
+
+		for(final BasketEntry entry : toRemove) {
+            this.contents.removeInt(entry);
 		}
 
 		updateNumUnits();
-        world.notifyBlockChange(x, y, z, Blocks.BASKET.id());
+        world.notifyBlockChange(this.x, this.y, this.z, Blocks.BASKET.id());
 	}
 
     @Override
-    public void readAdditionalData(@NotNull CompoundTag compoundTag) {
+    public void readAdditionalData(@NotNull final CompoundTag compoundTag) {
         final ListTag itemsTag = compoundTag.getList("Items");
-        contents.clear();
+        this.contents.clear();
         for (int i = 0; i < itemsTag.tagCount(); i++)
         {
             final CompoundTag itemTag = (CompoundTag) itemsTag.tagAt(i);
-            BasketEntry entry = BasketEntry.read(itemTag);
+            final BasketEntry entry = BasketEntry.read(itemTag);
             final int count = itemTag.getShort("Count");
-            contents.put(entry, count);
+            this.contents.put(entry, count);
         }
         updateNumUnits();
     }
@@ -120,21 +122,23 @@ public class TileEntityBasket extends TileEntity
     @Override
     public void tick()
     {
-        if (worldObj != null && worldObj.isClientSide) return;
-        if (carriedBlock != null && carriedBlock.world.isClientSide) return;
-
-        double posX, posY, posZ;
-        World workingWorld;
-        if (worldObj != null) {
-            workingWorld = worldObj;
-            posX = x;
-            posY = y;
-            posZ = z;
-        } else if (carriedBlock != null) {
-            workingWorld = carriedBlock.world;
-            posX = carriedBlock.holder.x - 0.5;
-            posY = carriedBlock.holder.y - carriedBlock.holder.heightOffset;
-            posZ = carriedBlock.holder.z - 0.5;
+        if (this.worldObj != null && this.worldObj.isClientSide) return;
+        if (this.carriedBlock != null && this.carriedBlock.world.isClientSide) return;
+
+        final double posX;
+        final double posY;
+        final double posZ;
+        final World workingWorld;
+        if (this.worldObj != null) {
+            workingWorld = this.worldObj;
+            posX = this.x;
+            posY = this.y;
+            posZ = this.z;
+        } else if (this.carriedBlock != null) {
+            workingWorld = this.carriedBlock.world;
+            posX = this.carriedBlock.holder.x - 0.5;
+            posY = this.carriedBlock.holder.y - this.carriedBlock.holder.heightOffset;
+            posZ = this.carriedBlock.holder.z - 0.5;
         } else {
             return;
         }
@@ -163,35 +167,35 @@ public class TileEntityBasket extends TileEntity
 
         if (shouldUpdate)
         {
-            if (worldObj != null) {
-                worldObj.notifyBlockChange(x, y, z, Blocks.BASKET.id());
+            if (this.worldObj != null) {
+                this.worldObj.notifyBlockChange(this.x, this.y, this.z, Blocks.BASKET.id());
             }
             updateNumUnits();
         }
     }
 
-    private boolean importItemStack(ItemStack stack)
+    private boolean importItemStack(final ItemStack stack)
     {
-        BasketEntry entry = new BasketEntry(stack.itemID, stack.getMetadata(), stack.getData());
-        int sizeUnits = getItemSizeUnits(stack.getItem());
-        int freeUnits = getMaxUnits() - numUnitsInside;
-        int itemsToTake = Math.min(freeUnits / sizeUnits, stack.stackSize);
+        final BasketEntry entry = new BasketEntry(stack.itemID, stack.getMetadata(), stack.getData());
+        final int sizeUnits = getItemSizeUnits(stack.getItem());
+        final int freeUnits = getMaxUnits() - this.numUnitsInside;
+        final int itemsToTake = Math.min(freeUnits / sizeUnits, stack.stackSize);
         if (itemsToTake <= 0) return false;
         stack.stackSize -= itemsToTake;
-        int currentItemsInBE = contents.getOrDefault(entry, 0);
+        int currentItemsInBE = this.contents.getOrDefault(entry, 0);
         currentItemsInBE += itemsToTake;
-        contents.put(entry, currentItemsInBE);
+        this.contents.put(entry, currentItemsInBE);
         return true;
     }
 
     @Override
-    public void writeAdditionalData(@NotNull CompoundTag compoundTag)
+    public void writeAdditionalData(@NotNull final CompoundTag compoundTag)
     {
         final ListTag itemsTag = new ListTag();
-        for (Map.Entry<BasketEntry, Integer> entry : contents.entrySet())
+        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet())
         {
             final CompoundTag itemTag = new CompoundTag();
-            itemTag.putShort("Count", (short)(int)entry.getValue());
+            itemTag.putShort("Count", (short) entry.getIntValue());
             BasketEntry.write(itemTag, entry.getKey());
             itemsTag.addTag(itemTag);
         }
@@ -205,38 +209,38 @@ public class TileEntityBasket extends TileEntity
     }
 
     @Override
-    public void dropContents(World world, int x, int y, int z) {
+    public void dropContents(final World world, final int x, final int y, final int z) {
         super.dropContents(world, x, y, z);
         final Random rand = new Random();
 
-        for (Map.Entry<BasketEntry, Integer> entry : contents.entrySet())
+        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet())
         {
-            BasketEntry be = entry.getKey();
-            int numItems = entry.getValue();
+            final BasketEntry be = entry.getKey();
+            int numItems = entry.getIntValue();
 
             while (numItems > 0)
             {
-                int maxStackSize = be.getItem().getItemStackLimit(null);
+                final int maxStackSize = be.getItem().getItemStackLimit(null);
                 int stackSize = maxStackSize;
-                int remainingItems = numItems - maxStackSize;
+                final int remainingItems = numItems - maxStackSize;
                 if (remainingItems < 0) stackSize = numItems;
                 numItems -= stackSize;
                 dropItemStack(rand, new ItemStack(be.id, stackSize, be.metadata, be.tag));
             }
         }
 
-        contents.clear();
+        this.contents.clear();
 
         world.notifyBlockChange(x, y, z, Blocks.BASKET.id());
         updateNumUnits();
     }
 
     @Override
-    public void heldTick(World world, Entity holder) {
+    public void heldTick(final World world, final Entity holder) {
         tick();
     }
     @Override
-    public boolean canBeCarried(World world, Entity potentialHolder) {
+    public boolean canBeCarried(final World world, final Entity potentialHolder) {
         return true;
     }
 
@@ -246,23 +250,23 @@ public class TileEntityBasket extends TileEntity
         public final int metadata;
         public final CompoundTag tag;
 
-        public BasketEntry(int id, int metadata, CompoundTag tag)
+        public BasketEntry(final int id, final int metadata, final CompoundTag tag)
         {
             this.id = id;
             this.metadata = metadata;
             this.tag = tag;
         }
 
-        public static BasketEntry read(CompoundTag tag)
+        public static BasketEntry read(final CompoundTag tag)
         {
-            int id = tag.getShort("id");
-            int damage = tag.getShort("Damage");
-            CompoundTag data = tag.getCompound("Data");
+            final int id = tag.getShort("id");
+            final int damage = tag.getShort("Damage");
+            final CompoundTag data = tag.getCompound("Data");
 
             return new BasketEntry(id, damage, data);
         }
 
-        public static void write(CompoundTag tag, BasketEntry entry)
+        public static void write(final CompoundTag tag, final BasketEntry entry)
         {
             tag.putShort("id", (short) entry.id);
             tag.putShort("Damage", (short) entry.metadata);
@@ -271,29 +275,28 @@ public class TileEntityBasket extends TileEntity
 
         public Item getItem()
         {
-            return Item.itemsList[id];
+            return Item.itemsList[this.id];
         }
 
         @Override
-        public boolean equals(Object obj)
+        public boolean equals(final Object obj)
         {
             if (!(obj instanceof BasketEntry)) return false;
-            BasketEntry other = (BasketEntry) obj;
+            final BasketEntry other = (BasketEntry) obj;
             if (this.id != other.id || this.metadata != other.metadata) return false;
-            if (this.tag.getValues().size() > 2 || other.tag.getValues().size() > 2) return false;
-            return true;
+            return this.tag.getValues().size() <= 2 && other.tag.getValues().size() <= 2;
         }
 
         @Override
         public int hashCode()
         {
-            if (tag.getValues().size() <= 2)
+            if (this.tag.getValues().size() <= 2)
             {
-                return Objects.hash(id, metadata);
+                return Objects.hash(this.id, this.metadata);
             }
             else
             {
-                return Objects.hash(id, metadata, tag);
+                return Objects.hash(this.id, this.metadata, this.tag);
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java b/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java
index 0467a8afa..4d47adc00 100644
--- a/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java
+++ b/game/core/src/main/java/net/minecraft/core/block/logic/RailDirection.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.block.logic;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.HashMap;
@@ -40,7 +42,7 @@ public enum RailDirection {
         0, 0, -1,
         1, 0, 0);
 
-    private static final Map<Integer, RailDirection> directionMap = new HashMap<>();
+    private static final Int2ObjectMap<RailDirection> directionMap = new Int2ObjectArrayMap<>();
     public final int meta;
     private final boolean sloped;
     private final boolean straight;
diff --git a/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java b/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
index c1957bf50..a31644738 100644
--- a/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/material/MaterialColor.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.block.material;
 
 
+import it.unimi.dsi.fastutil.ints.Int2IntMap;
+import it.unimi.dsi.fastutil.ints.Int2IntOpenHashMap;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 
@@ -80,7 +82,7 @@ public class MaterialColor {
     public static final MaterialColor paintedRed = new MaterialColor(62, 0xed33434);
     public static final MaterialColor paintedBlack = new MaterialColor(63, 0x020202);
     // <<<<< Painted Colors pallet >>>>>
-    private static final Map<Integer, Integer> blockIdColorIndexMap = new HashMap<>();
+    private static final Int2IntMap blockIdColorIndexMap = new Int2IntOpenHashMap();
     private final int col;
     public final int id;
     private MaterialColor(int id, int col)
diff --git a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index e038508dc..5b4bd4295 100644
--- a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -38,148 +38,148 @@ public abstract class BlockTags
     /**
      * block can be mined by {@link ItemToolPickaxe ItemToolPickaxe}.
      */
-    public static Tag<Block<?>> MINEABLE_BY_PICKAXE = Tag.of("mineable_by_pickaxe");
+    public static final Tag<Block<?>> MINEABLE_BY_PICKAXE = Tag.of("mineable_by_pickaxe");
     /**
      * block can be mined by {@link ItemToolAxe ItemToolAxe}.
      */
-    public static Tag<Block<?>> MINEABLE_BY_AXE = Tag.of("mineable_by_axe");
+    public static final Tag<Block<?>> MINEABLE_BY_AXE = Tag.of("mineable_by_axe");
     /**
      * block can be mined by {@link ItemToolShovel ItemToolShovel}.
      */
-    public static Tag<Block<?>> MINEABLE_BY_SHOVEL = Tag.of("mineable_by_shovel");
+    public static final Tag<Block<?>> MINEABLE_BY_SHOVEL = Tag.of("mineable_by_shovel");
     /**
      * block can be mined by {@link ItemToolHoe ItemToolHoe}.
      */
-    public static Tag<Block<?>> MINEABLE_BY_HOE = Tag.of("mineable_by_hoe");
+    public static final Tag<Block<?>> MINEABLE_BY_HOE = Tag.of("mineable_by_hoe");
     /**
      * block can be mined by {@link ItemToolSword ItemToolSword}.
      */
-    public static Tag<Block<?>> MINEABLE_BY_SWORD = Tag.of("mineable_by_sword");
+    public static final Tag<Block<?>> MINEABLE_BY_SWORD = Tag.of("mineable_by_sword");
     /**
      * block can be mined by {@link ItemToolShears ItemShears}.
      */
-    public static Tag<Block<?>> MINEABLE_BY_SHEARS = Tag.of("mineable_by_shears");
+    public static final Tag<Block<?>> MINEABLE_BY_SHEARS = Tag.of("mineable_by_shears");
     /**
      * derived block has the properties of water.
      */
-    public static Tag<Block<?>> IS_WATER = Tag.of("is_water");
+    public static final Tag<Block<?>> IS_WATER = Tag.of("is_water");
     /**
      * derived block has the properties of lava.
      */
-    public static Tag<Block<?>> IS_LAVA = Tag.of("is_lava");
+    public static final Tag<Block<?>> IS_LAVA = Tag.of("is_lava");
     /**
      * {@link BlockLogicFlower BlockFlower}-derived blocks can be placed on this block.
      */
-    public static Tag<Block<?>> GROWS_FLOWERS = Tag.of("grows_flowers");
+    public static final Tag<Block<?>> GROWS_FLOWERS = Tag.of("grows_flowers");
     /**
      * {@link BlockLogicSugarcane BlockSugarcane} can be placed on this block.
      */
-    public static Tag<Block<?>> GROWS_SUGAR_CANE = Tag.of("grows_sugar_cane");
+    public static final Tag<Block<?>> GROWS_SUGAR_CANE = Tag.of("grows_sugar_cane");
     /**
      * {@link BlockLogicCactus BlockCactus} can be placed on this block.
      */
-    public static Tag<Block<?>> GROWS_CACTI = Tag.of("grows_cacti");
+    public static final Tag<Block<?>> GROWS_CACTI = Tag.of("grows_cacti");
     /**
      * {@link net.minecraft.core.world.generate.feature.tree.WorldFeatureTree WorldFeatureTree} and its variations can be placed on this block.
      */
-    public static Tag<Block<?>> GROWS_TREES = Tag.of("grows_trees");
-    public static Tag<Block<?>> GROWS_SPINIFEX = Tag.of("grows_spinifex");
+    public static final Tag<Block<?>> GROWS_TREES = Tag.of("grows_trees");
+    public static final Tag<Block<?>> GROWS_SPINIFEX = Tag.of("grows_spinifex");
     /**
      * This block is destroyed when {@link BlockLogicFluid BlockFluid}-derived blocks try to move into its space.
      */
-    public static Tag<Block<?>> BROKEN_BY_FLUIDS = Tag.of("broken_by_fluids");
+    public static final Tag<Block<?>> BROKEN_BY_FLUIDS = Tag.of("broken_by_fluids");
     /**
      * The block can have other blocks placed "into" it, like how {@link BlockLogicTallGrass BlockTallGrass} behaves.
      */
-    public static Tag<Block<?>> PLACE_OVERWRITES = Tag.of("place_overwrites");
+    public static final Tag<Block<?>> PLACE_OVERWRITES = Tag.of("place_overwrites");
     /**
      * Passive mobs can spawn on this block.
      */
-    public static Tag<Block<?>> PASSIVE_MOBS_SPAWN = Tag.of("passive_mobs_spawn");
+    public static final Tag<Block<?>> PASSIVE_MOBS_SPAWN = Tag.of("passive_mobs_spawn");
     /**
      * {@link MobFireflyCluster MobFireflyCluster} can spawn on this block.
      */
-    public static Tag<Block<?>> FIREFLIES_CAN_SPAWN = Tag.of("fireflies_can_spawn");
+    public static final Tag<Block<?>> FIREFLIES_CAN_SPAWN = Tag.of("fireflies_can_spawn");
     /**
      * {@link BlockLogicFence BlockFence} visually connects to this block.
      */
-    public static Tag<Block<?>> FENCES_CONNECT = Tag.of("fences_connect");
+    public static final Tag<Block<?>> FENCES_CONNECT = Tag.of("fences_connect");
     /**
      * This block does <b>not</b> appear in the creative menu.
      */
-    public static Tag<Block<?>> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
+    public static final Tag<Block<?>> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
     /**
      * This block drops as if using a silk touch tool when broken by {@link ItemToolShears ItemShears}.
      */
-    public static Tag<Block<?>> SHEARS_DO_SILK_TOUCH = Tag.of("shears_do_silk_touch");
+    public static final Tag<Block<?>> SHEARS_DO_SILK_TOUCH = Tag.of("shears_do_silk_touch");
     /**
      * This block can be skated on using {@link net.minecraft.core.item.Items#ARMOR_BOOTS_ICESKATES ice skates}.
      */
-    public static Tag<Block<?>> SKATEABLE = Tag.of("skateable");
+    public static final Tag<Block<?>> SKATEABLE = Tag.of("skateable");
     /**
      * Detects grass surface blocks so that {@link CavesLargeFeature MapGenCaves} can replace any exposed dirt with grass once it has finished generating a surface cave.
      */
-    public static Tag<Block<?>> CAVE_GEN_REPLACES_SURFACE = Tag.of("cave_gen_replaces_surface");
+    public static final Tag<Block<?>> CAVE_GEN_REPLACES_SURFACE = Tag.of("cave_gen_replaces_surface");
     /**
      * Determines which blocks {@link CavesLargeFeature MapGenCaves} can cut through
      */
-    public static Tag<Block<?>> CAVES_CUT_THROUGH = Tag.of("caves_cut_through");
+    public static final Tag<Block<?>> CAVES_CUT_THROUGH = Tag.of("caves_cut_through");
     /**
      * Blocks such as {@link BlockLogicLanternFirefly BlockLanternFirefly} can hang off this block.
      */
-    public static Tag<Block<?>> CAN_HANG_OFF = Tag.of("can_hang_off");
+    public static final Tag<Block<?>> CAN_HANG_OFF = Tag.of("can_hang_off");
     /**
      * Blocks like snow layers play their own sound when walking in them, instead of the sound of the block below
      */
-    public static Tag<Block<?>> OVERRIDE_STEPSOUND = Tag.of("override_stepsound");
+    public static final Tag<Block<?>> OVERRIDE_STEPSOUND = Tag.of("override_stepsound");
     /**
      * {@link BlockLogicFenceChainlink BlockFenceChainlink} visually connects to this block.
      */
-    public static Tag<Block<?>> CHAINLINK_FENCES_CONNECT = Tag.of("chainlink_fences_connect");
+    public static final Tag<Block<?>> CHAINLINK_FENCES_CONNECT = Tag.of("chainlink_fences_connect");
     /**
      * Prevent mobs from spawning inside these blocks. Used for blocks with no collision like rails and redstone components
      */
-    public static Tag<Block<?>> PREVENT_MOB_SPAWNS = Tag.of("prevent_mob_spawns");
+    public static final Tag<Block<?>> PREVENT_MOB_SPAWNS = Tag.of("prevent_mob_spawns");
     /**
      * Block can be planted inside a {@link BlockLogicJar JarBlock}
      */
-    public static Tag<Block<?>> PLANTABLE_IN_JAR = Tag.of("plantable_in_jar");
+    public static final Tag<Block<?>> PLANTABLE_IN_JAR = Tag.of("plantable_in_jar");
     /**
      * Block allows fire to burn forever on it {@link BlockLogicFire BlockFire}
      */
-    public static Tag<Block<?>> INFINITE_BURN = Tag.of("infinite_burn");
+    public static final Tag<Block<?>> INFINITE_BURN = Tag.of("infinite_burn");
     /**
      * Block allows fire to burn forever on it {@link BlockFire BlockFire}
      */
-    public static Tag<Block<?>> INFINITE_BURN_COLD = Tag.of("infinite_burn_cold");
+    public static final Tag<Block<?>> INFINITE_BURN_COLD = Tag.of("infinite_burn_cold");
     /**
      * Block is broken on contact with an {@link EntityBoat EntityBoat}
      */
-    public static Tag<Block<?>> BOAT_BREAKS = Tag.of("boat_breaks");
+    public static final Tag<Block<?>> BOAT_BREAKS = Tag.of("boat_breaks");
     /**
      * Block extends the range of a motion sensor's sight.
      */
-    public static Tag<Block<?>> EXTENDS_MOTION_SENSOR_RANGE = Tag.of("extends_motion_sensor_range");
+    public static final Tag<Block<?>> EXTENDS_MOTION_SENSOR_RANGE = Tag.of("extends_motion_sensor_range");
     /**
      * When broken, items go into the player's inventory immediately instead of being dropped
      */
-    public static Tag<Block<?>> INSTANT_PICKUP = Tag.of("instant_pickup");
+    public static final Tag<Block<?>> INSTANT_PICKUP = Tag.of("instant_pickup");
     /**
      * Sheep will follow the player if they are holding this block.
      */
-    public static Tag<Block<?>> SHEEPS_FAVOURITE_BLOCK = Tag.of("sheeps_favourite_block");
+    public static final Tag<Block<?>> SHEEPS_FAVOURITE_BLOCK = Tag.of("sheeps_favourite_block");
     /**
      * Pigs will follow the player if they are holding this block.
      */
-    public static Tag<Block<?>> PIGS_FAVOURITE_BLOCK = Tag.of("pigs_favourite_block");
+    public static final Tag<Block<?>> PIGS_FAVOURITE_BLOCK = Tag.of("pigs_favourite_block");
     /**
      * Nether mobs can spawn on this block {@link MobZombiePig MobZombiePig}}.
      */
-    public static Tag<Block<?>> NETHER_MOBS_SPAWN = Tag.of("nether_mobs_spawn");
+    public static final Tag<Block<?>> NETHER_MOBS_SPAWN = Tag.of("nether_mobs_spawn");
     /**
      * Will drop block when piston extends into it
      */
-    public static Tag<Block<?>> PISTON_CRUSHING = Tag.of("piston_crushing");
+    public static final Tag<Block<?>> PISTON_CRUSHING = Tag.of("piston_crushing");
 
     public static List<Tag<Block<?>>> TAG_LIST;
 
diff --git a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
index b086c770c..1ca5ca011 100644
--- a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
@@ -1,5 +1,7 @@
 package net.minecraft.core.crafting;
 
+import it.unimi.dsi.fastutil.ints.Int2IntMap;
+import it.unimi.dsi.fastutil.ints.Int2IntOpenHashMap;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.block.Blocks;
 
@@ -9,7 +11,7 @@ import java.util.Map;
 public class LookupFuelFurnace {
 
 	public static final LookupFuelFurnace instance = new LookupFuelFurnace();
-	protected final Map<Integer, Integer> fuelList = new HashMap<>();
+	protected final Int2IntMap fuelList = new Int2IntOpenHashMap();
 
 	protected LookupFuelFurnace() {
 		register();
@@ -89,10 +91,10 @@ public class LookupFuelFurnace {
 	}
 
 	public int getFuelYield(int id) {
-		return fuelList.get(id) == null ? 0 : fuelList.get(id);
+		return fuelList.getOrDefault(id, 0);
 	}
 
-	public Map<Integer, Integer> getFuelList() {
+	public Int2IntMap getFuelList() {
 		return fuelList;
 	}
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
index 50d0fb1ad..b83ef34f1 100644
--- a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
+++ b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyBiomes.java
@@ -1,5 +1,10 @@
 package net.minecraft.core.data.legacy;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 
@@ -8,8 +13,8 @@ import java.util.Map;
 
 public abstract class LegacyBiomes
 {
-    private static final Map<Integer, Biome> idToBiomeMap = new HashMap<>();
-    private static final Map<Biome, Integer> biomeToIdMap = new HashMap<>();
+    private static final Int2ObjectMap<Biome> idToBiomeMap = new Int2ObjectArrayMap<>();
+    private static final Object2IntMap<Biome> biomeToIdMap = new Object2IntArrayMap<>();
 
     private static void register(Biome biome, int id)
     {
@@ -24,7 +29,7 @@ public abstract class LegacyBiomes
 
     public static int getBiomeId(Biome biome)
     {
-        return biomeToIdMap.get(biome);
+        return biomeToIdMap.getInt(biome);
     }
 
     static
diff --git a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java
index 53eb26ac7..c140cae3b 100644
--- a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java
@@ -1,5 +1,9 @@
 package net.minecraft.core.data.legacy;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
 
@@ -8,8 +12,8 @@ import java.util.Map;
 
 public abstract class LegacyWorldTypes
 {
-    private static final Map<Integer, WorldType> idToWorldTypeMap = new HashMap<>();
-    private static final Map<WorldType, Integer> worldTypeToIdMap = new HashMap<>();
+    private static final Int2ObjectMap<WorldType> idToWorldTypeMap = new Int2ObjectArrayMap<>();
+    private static final Object2IntMap<WorldType> worldTypeToIdMap = new Object2IntArrayMap<>();
     private static final Map<String, WorldType> keyToWorldTypeMap = new HashMap<>();
     private static final Map<WorldType, String> worldTypeToKeyMap = new HashMap<>();
 
@@ -33,7 +37,7 @@ public abstract class LegacyWorldTypes
 
     public static int getWorldTypeId(WorldType worldType)
     {
-        return worldTypeToIdMap.get(worldType);
+        return worldTypeToIdMap.getInt(worldType);
     }
 
     public static String getWorldTypeKey(WorldType worldType)
